# class Exception

- Exception
- Reference
- Object

##
Overview

Represents errors that occur during application execution.

Exception and its descendants are used to communicate between raise and rescue statements in `begin ... end` blocks. Exception objects carry information about the exception – its type (the exception’s class name), an optional descriptive string, and optional traceback information. Exception subclasses may add additional information.

##
Direct Known Subclasses

- ArgumentError
- Base64::Error
- Channel::ClosedError
- Concurrent::CanceledError
- ConcurrentExecutionException
- Crypto::Bcrypt::Error
- CSV::Error
- Debug::ELF::Error
- DivisionByZeroError
- Enumerable::EmptyError
- Errno
- File::BadPatternError
- Flate::Error
- Gzip::Error
- HTTP::FormData::Error
- IndexError
- INI::ParseException
- InvalidBigDecimalException
- InvalidByteSequenceError
- IO::Error
- IO::Timeout
- JSON::Error
- KeyError
- MIME::Error
- MIME::Multipart::Error
- NilAssertionError
- NotImplementedError
- OAuth2::Error
- OAuth::Error
- OpenSSL::Error
- OptionParser::Exception
- OverflowError
- Path::Error
- Socket::Error
- System::Group::NotFoundError
- System::User::NotFoundError
- Time::FloatingTimeConversionError
- Time::Format::Error
- Time::Location::InvalidLocationNameError
- Time::Location::InvalidTimezoneOffsetError
- Time::Location::InvalidTZDataError
- TypeCastError
- URI::Error
- UUID::Error
- XML::Error
- YAML::Error
- Zip::Error
- Zlib::Error

##
Defined in:

##
Constructors

- .new(message : String? = nil, cause : Exception? = nil)

##
Instance Method Summary

- #backtrace

  Returns any backtrace associated with the exception.

- #backtrace?

  Returns any backtrace associated with the exception if the call stack exists.

- #callstack : CallStack?
- #callstack=(callstack : CallStack?)
- #cause : Exception?

  Returns the previous exception at the time this exception was raised.

- #inspect(io : IO) : Nil

  Appends a String representation of this object which includes its class name, its object address and the values of all instance variables.

- #inspect_with_backtrace(io : IO) : Nil
- #inspect_with_backtrace : String
- #message : String?
- #to_s(io : IO) : Nil

  Appends a short String representation of this object which includes its class name and its object address.

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, __crystal_pseudo_! : Bool __crystal_pseudo_!, __crystal_pseudo_as(type : Class) __crystal_pseudo_as, __crystal_pseudo_as?(type : Class) __crystal_pseudo_as?, __crystal_pseudo_is_a?(type : Class) : Bool __crystal_pseudo_is_a?, __crystal_pseudo_nil? : Bool __crystal_pseudo_nil?, __crystal_pseudo_responds_to?(name : Symbol) : Bool __crystal_pseudo_responds_to?, class class, dup dup, hash(hasher)
hash hash, inspect : String
inspect(io : IO) : Nil inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Constructor Detail

def self.new(message : String? = nil, cause : Exception? = nil) #

##
Instance Method Detail

def backtrace #

Returns any backtrace associated with the exception. The backtrace is an array of strings, each containing “0xAddress: Function at File Line Column”.

def backtrace? #

Returns any backtrace associated with the exception if the call stack exists. The backtrace is an array of strings, each containing “0xAddress: Function at File Line Column”.

def callstack : CallStack? #
def callstack=(callstack : CallStack?) #
def cause : Exception? #

Returns the previous exception at the time this exception was raised. This is useful for wrapping exceptions and retaining the original exception information.

def inspect(io : IO) : Nil #
Description copied from class Reference

Appends a String representation of this object which includes its class name, its object address and the values of all instance variables.

    class Person
      def initialize(@name : String, @age : Int32)
      end
    end

    Person.new("John", 32).inspect # => #<Person:0x10fd31f20 @name="John", @age=32>

def inspect_with_backtrace(io : IO) : Nil #
def inspect_with_backtrace : String #
def message : String? #
def to_s(io : IO) : Nil #
Description copied from class Reference

Appends a short String representation of this object which includes its class name and its object address.

    class Person
      def initialize(@name : String, @age : Int32)
      end
    end

    Person.new("John", 32).to_s # => #<Person:0x10a199f20>